# Scotty TNG - ping/snmp based realtime network monitoring
#
# $Id: notify.rb 81 2008-09-25 12:40:17Z liske $
#
# Authors:
#   Thomas Liske <liske@ibh.de>
#   Andre Ellguth <ellguth@ibh.de>
#
# Copyright Holder:
#   2008 (C) IBH IT-Service GmbH [http://www.ibh.de/]
#
# License:
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this package; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#

class Notify
    def self._notification(action, status, color, msg)
	    action.each{|ac|
		attr = ac[1]

		begin
		    p = fork{
			eval Client.getCmds[ac[0]]
			Kernel.exit!
		    }
		    Process.detach(p)
		rescue
		    Logger.logtxt("Error running action command '#{ac[0]}': #{$!}")
		end
	    }
    end

    def self.notification(action, interval, status, color, msg)
	_notification(action, status, color, msg)
	if (interval > 0) then
	    return Gtk.timeout_add(interval*1000) { _notification(action, status, color, msg) }
	else
	    return 0
	end
    end

    def self.terminate(id)
	Gtk.timeout_remove(id)
    end
end
